"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = queueReducer;

var _zSchema = require("z-schema");

var _zSchema2 = _interopRequireDefault(_zSchema);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var validator = new _zSchema2.default(); // import Ajv from "ajv";
// const ajv = new Ajv({ allErrors: true });
function queueReducer(state, action) {
  if (state.game.queue && state.game.queue.length > 0) {
    var schema = state.game.queue[0];
    // const validate = ajv.compile(schema);

    var valid = validator.validate(action, schema);
    if (!valid) {
      throw new Error(JSON.stringify({ action: action, errors: validator.getLastErrors() }, null, 2));
    }
  }
  if (state.game.nextActions) {
    return Object.assign({}, state, {
      game: Object.assign({}, state.game, {
        queue: state.game.nextActions.map(function (action) {
          return {
            type: "object",
            properties: {
              type: {
                type: "string",
                enum: [action.action.type]
              }
            }
          };
        })
      })
    });
  }

  return state;
}
//# sourceMappingURL=queue-reducer.js.map