"use strict";

var _queueReducer = require("./queue-reducer");

var _queueReducer2 = _interopRequireDefault(_queueReducer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe("queueReducer", function () {
  it("should convert nextActions to queue", function () {
    var state = {
      game: {
        nextActions: [{
          action: { type: "TEST_ACTION" }
        }]
      }
    };
    var after = (0, _queueReducer2.default)(state, { type: "TEST_ACTION_2" });
    expect(after.game.queue[0].type).toEqual("object");
    expect(after.game.queue[0].properties.type.enum[0]).toEqual("TEST_ACTION");
  });

  it("should accept/reject actions", function () {
    var state = {
      game: {
        queue: [{
          type: "object",
          properties: {
            type: {
              enum: ["TEST_ACTION"]
            }
          }
        }]
      }
    };
    (0, _queueReducer2.default)(state, { type: "TEST_ACTION" });
    expect(function () {
      (0, _queueReducer2.default)(state, { type: "INVALID_ACTION" });
    }).toThrow();
    expect(function () {
      (0, _queueReducer2.default)(state, null);
    }).toThrow();
  });
});
//# sourceMappingURL=queue-reducer.spec.js.map